CS590A Distributed Network Algorithms Prof. Gopal Pandurangan

735 Views

Download Presentation
## CS590A Distributed Network Algorithms Prof. Gopal Pandurangan

- - - - - - - - - - - - - - - - - - - - - - - - - - - E N D - - - - - - - - - - - - - - - - - - - - - - - - - - -

**CS590A Distributed Network Algorithms**Prof. Gopal Pandurangan**An efficient distributed algorithm for constructing small**dominating setsLujun Jia, Rajmohan Rajaraman, Torsten SuelJournal of Distributed Computing 2002(15) Presented by: Xun Zhou 2007.10.30**Outline**• Overview and Related Work • Local Randomized Greedy Algorithm (LRG) • Analysis : Time Complexity and Approximation Ratio • Generalizations • Open problems and comments**Definition**The dominating set problem asks for a small subset D of nodes in a graph such that every node is either in D or adjacent to a node in D. Result size of MDS (d*), Optimal Size : d Approximation Ratio: (d*)/d**Related Work (1)**• Greedy Algorithm (A distributed implementation in Lecture 13 ): Time Complexity: O(log n logΔ) Approximation Ratio: H(Δ) = O(logΔ) • All nodes must know n and Δ first (Δ: Max degree) • Drawback: if Δ is not known, then O( log2 n) rounds**Related Work (2):**Distributed Greedy Algorithm: DDCH in reference [20] Span(v) :The number of uncovered neighbors of v (including v) White node: uncovered node.**Related Work (2)’**• Drawback: In some particular graphs where there is a long chain of nodes with decreasing degrees, the number of rounds until completion may be proportional to the length of the chain. • To Solve this: Span rounded span**Example**__ Time Complexity of the above graph :Ω(√ n )**Example**• In this Kn/3 graph, run time is n/3 round. • Each round add exactly 1 node: Inefficient**Main Result**• Local Randomized Greedy algorithm (LRG) Time Complexity : O(log n logΔ) Approximation Ratio : H(Δ) = O(logΔ) of the optimal in expectation O(log n ) with high probability (whp) Δ is the maximum degree + 1 in the graph • No pre-request for n and Δ**Problems and Results(2)**• Generalizations: Multi-MDS (MMDS): Find a dominating set that covers v at least r(v) times for all v ∈ V . Time Complexity : O(log n logR logΔ) whp. O(logΔ) in expectation and O(log n) whp, where R equals max u∈V r(u). • Weighted dominating set problem: We wish to select a dominating set of minimum total weight Same approximation ratio as MDS. Time Complexity: O(log n log(ΔW)), where W is the ratio of the maximum and minimum weights.**LRG : Span, Candidate, Support and Dominator Selection:**• Span d(v): The number of uncovered nodes that are adjacent to v (including v itself if uncovered). • Let the rounded span of node v be the smallest power of base b that is at least d(v), where b > 1 is a real constant. • We say that a node v ∈ V is a candidateIf is at least for all w ∈ V within distance 2 of v. For each candidate v, let cover C(v) denote the set of uncovered nodes that v covers (v and its neighbors). • Support calculation: For each uncovered node u, we calculate its support s(u), which is the number of candidates that cover u. • Dominator Selection: For each candidate v, we add v to D with probability 1/med(v), where med(v) is the median support of all the nodes in C(v).**LRG**• Do the following steps in each round: • 1. Node v is a candidate for joining the dominating set if its span w(v) rounded to the next power of 2 is maximal within distance 2. • 2. Each white node u computes its support s(u), which is the number of candidates that cover u. • 3. For a candidate v, let m(v) be the median support of all white neighbors. v joins the dominating set with probability 1/m(v).**LRG (cont)**• Once a node u and all of the neighbors of u are covered, u need not participate in the algorithm any longer (other than as an intermediate node for routing messages). • Covered nodes still have chance to be candidates, while those in D don’t. • The algorithm will stop when all the nodes are covered.**Analysis – Time Complexity**• Lemma 3.1. If v1and v2are two candidates in any connected component of H, then = v1 v2 Candidate Node Node covered by candidates**Proof 3.1**• Fixed round, H = (V’ ,E’) is the subgraph of G where V is the union of the set of all candidates in the round and the set of nodes covered by the candidates, and E is the set of edges (v,w) where v is a candidate in the round and w ∈ C(v). • Proof. Consider any path p connecting v1 and v2. From the definition of subgraph H, at least every alternate node on p is a candidate. From the definition of a candidate, two candidates within distance 2 have the same rounded span. Hence, the desired claim holds.**Time Complexity**• Lemma 3.2. If m is the maximum rounded span of any node at the start of a round and Φ and Φ’ are them-potentials at the start and end of the round, then E[Φ’] ≤ dΦ for some positive constant d < 1. • Lemma establishes a bound on the expected decrease in the m-potential in any round. • To prove Lemma 3.2, we need to introduce some definitions, and use Lemma 3.3 and Lemma 3.4.**Proof 3.2 - definition**• i-potential : m : maximum rounded span of all the nodes at the start of the round. • For each v, sort nodes in C(v) in non-decreasing order, according to s(u) of each node in C(v). T(v): Top half of the C(v). B(v): Bottom half • v is good for u if u is in T(v) • u is nice if at least s(u)/4 nodes are good for u. • Ps(v) : The probability that candidate v will be added to D at the end of the round. • Pc(u) denote the probability that node u will be covered at the end of the round.**Proof 3.2 – Lemma 3.3**• Lemma 3.3.**Proof 3.2 – Definition (for 3.4)**• Each element in C(v) for any v with rounded span m, is anentry. Thus, Φ is the total number of entries (a node may have entries in several sets C(v)). • Any entry that occurs in T(v), for some v, is referred to as a top entry. Finally, any occurrence of a nice node in T(v) is referred to as a nice top entry.**Proof 3.2 – Lemma 3.4**• Lemma 3.4. At least one-third of the total entries are nice top entries. • Proof 3.4: Fix a connected component S in which the maximum rounded span is m. By Lemma 3.1, all candidates in S have the same rounded span. • Let x (resp., y) denote the total number of entries (resp., number of non-nice top entries) in S. It follows from the definition of nice nodes that for any nice node u the number of candidates v such that T(v) contains u is at least s(u)/4.**Proof 3.2 – Lemma 3.4**• Therefore, there exist at least 3y non-nice node entries in B(v). (Non-nice nodes appear in less than ¼ of all T(v) ) Clearly, x/2 − 3y ≥ 0, y ≤ x/6. Thus, the total number of nice node entries in T(v) is x/2 − y ≥ x/3. Adding over all connected components with rounded span m, we obtain the desired claim.**Proof 3.2**• Now we go back to prove 3.2 using the result of 3.3 and 3.4. • v : Any candidate in S • y,z : The number of nice top entries in C(v) at the start of/covered in the round. • By Lemma 3.3 : • Adding all Components with span m and invoke Lemma 3.4 : . 3.2 proved.**Theorem 1**• Theorem 1 :LRG terminates in O(log n logΔ) rounds whp. • Proof : Divide the running time of the algorithm into phases. A phase consists of a maximal sequence of rounds with the same maximum rounded span. The number of phases is at most the total number of distinct values for the rounded span, logbΔ. We now show that the number of rounds in each phase is O(log n) whp.**Theorem 1 (cont)**• Let T(P) denote the number of rounds remaining in the phase when the m-potential at the start of a round is P. Establish Probabilistic Recurrence for T. • For P > , we have T(P) = a(P) + T(P’), where a(P) = 1 for all P and P’is the random variable denoting the m-potential at the end of the round. • For P ≤ , we have T(P’) = 0. • Invoke a result on probabilistic recurrence relations due to Karp [18, Theorem 1.3] to obtain the following claim: • Let w = , where d is the constant in Lemma 3.2 .**Theorem 1 (cont)**For any instance with m-potential P, the number of rounds T(P) until the end of the phase satisfies the inequality: (1) for any constant c > 0. is the solution forτ (P) = a(P)+τ (dP), Which is a deterministic counterpart of Eq. (1), corresponding to the case: The m-potential decreases by exactly d in each round. P ≤ bnm , so each phase will end with at mostrounds. So combined with the number of phases, we get the final result:**Analysis - Approximation Ratio**• Theorem 2: LRG yields a dominating set of expected size4bHΔ· |OPT| andsize O(|OPT| ·log n) whp. • Proof: Assign cost (u) to node u in the round when u is covered. u is covered by v. • Set cost(u) to be 1/ . Note all v’s that cover u in the same round have the same rounded span.**Lemma 3.5**Lemma 3.5 :Σu∈V cost (u) ≤ HΔ· |OPT|. • Proof : Consider any v ∈ OPT. Let COPT(v) denote the set of nodes covered by v at the beginning of the algorithm, and let lbe |COPT(v)|. We sort all u ∈ COPT(v) to obtain the sequence u1, u2, ...,ulsuch that for any 1 ≤ i < j ≤ l , uiis assigned a cost not after uj. Then we have cost (ui) ≤ 1/(i+1). So, =HΔ Since every u is covered by a node v in OPT,we can get:**Lemma 3.6**• Lemma 3.6: If S is the set of candidates added to D in any round and Z is the total cost assigned in the round, then E[|S|] ≤ 4bE[Z]. • Proof : For any u ∈ V , let c(u) = 1/ , where u ∈ C(v). For any v ∈ S, we have |C(v)| ≥ d(v)/b. Thus we have: • For any u ∈ V , t(u) denote the number of candidates v that are added to D at the end of this round such that u ∈ B(v).**Lemma 3.6**• Note that t(u) = 0 if u is not covered or u ∈ B(v) for all v ∈ S that cover u. Thus, we have • Since c(u) is fixed in a given round and E[t(u)] equals Pr[t(u) > 0] · E[t(u) | t(u) > 0], we obtain Let W = {v : u ∈ B(v)} and let p(v) denote the probability that v is added to D for a given v ∈ W. For v ∈ W, since u ∈ B(v), we have p(v) ≤ 1/med(v) ≤ 1/s(u) ≤ 1/|W|. Thus,**Lemma 3.6**• Substituting the bound on E[t(u)|t(u) > 0] in Eq. (2), we get • E[|S|] ≤ 4b u∈V c(u) Pr[t(u) > 0] ≤ 4bE[Z]. Done.**Proof of Theorem 2**• Let Si denote the set of candidates added to the dominating set in round i, and let Zi denote the cost assigned in round i. Then the expected size of the dominating set computed by LRG is • This is the first half (expectation of ratio) of Theorem 2**Analysis - Approximation Ratio**Now we start to prove the second part of Theorem 2 (Ratio with high probability) Construct a tree T that captures all possible executions of LRG on the given network. Each path in T depicts one execution of LRG. The outcomes of rounds 1 though i−1 specify a particular path from the root of T to a vertex x. The vertex x depicts the coin tosses corresponding to the random dominator selections in round i. Transform T into a binary tree Tb. the path from root to any vertex in Tb, x, signifies a particular execution of LRG, E. Assign x a vertex value of px, which is the probability that the network node corresponding to vertex x is selected as a dominator at the last step of the execution E.**Add nodes to make all the value of paths equal to the max.**Tbis transformedinto a full binary tree Tf • Each non-leaf node is associated with a random variable Zx. which denotes the sum of the edge values along any path from x to a leaf vertex. • We can conclude : E[Zx] = 0. is the average vertex value of x. • Finally we have: • PrΓ[Z ≥ (β − 1) pN] < (eβ−1β−β)pN, (3)**Analysis - Approximation Ratio**• Theorem 3 Algorithm ε-LRG terminates in O(log n logΔ) rounds whp and achieves an expected approximation ratio of (1 + 3ε)HΔ, for any sufficiently small constant ε > 0. • ε-LRG: ε: positive real constant. select a candidate with probability ε/rε(v), where rε(v) is the support of rank among the supports of all nodes in C(v), set b to be ε+1 . • Modify the definitions of the sets T(v) and B(v): Let T(v) and B(v) denote the set of the top and bottom d(v)− entries, respectively. a node u is nice if at least εs(u)/2 candidates covering u are good for u.**Analysis - Approximation Ratio**Lemma 3.7: Lemma 3.8. At least an (ε/2)-fraction of the total entries are nice top entries. Proof 3.8 (in brief) : Each nice node u has at least εs(u)/2 entries in T(v), for each candidate v. there exist at least 2(1 − ε/2)y/ε non-nice node entries in B(v). Clearly, (1 − ε)x − 2(1 − ε/2)y/ε ≥ 0, from which we get y ≤ εx/2. So, the total number of nice node entries in T(v) is at least εx−εx/2 = εx/2 Adding all the components, we get the result.**Analysis - Approximation Ratio**• Lemma 3.9. If S is the set of candidates added to D in any round and Z is the total cost assigned in the round, then E[|S|] ≤ (1 + 3ε)bE[Z]. Proof 3.9 is a modification of proof 3.6 • Applying Lemma 3.9 over all rounds and invoking Lemma 3.5, we obtain the desired bound on the expected approximation ratio.**Tightness**• The analysis of LRG is tight to within constant • Consider the Network showed in Figure 3. 2i core nodes and 22i fringe nodes in level i. Number of nodes n = (4m3− 18)/7 + 2m. • In level i, the span of each core node is 22i + 2i if 1 ≤ i <logm, or 22i if i is logm. Since (22i+2i)/(22i−2+2i−1) and 22i/(22i−2 +2i−1) are both at least 2, core nodes of level i-1 won’t be covered until all fringe nodes in level i are covered. • Consider a level : at least 1 node in level i is uncovered, all nodes in level i+1…log m are covered.**For i ≥ (log m)/2**The probability that level i, for i ≥ (logm)/2, is covered in r = (logm)/8 rounds is at most The probability that level i takes at least (logm)/8 rounds to be covered is at least Adding over levels (logm)/2 through logm, the number of rounds LRG takes for this network is Ω(log2m) whp. The total running time is Ω(log n logΔ) whp. The analysis is tight.**4.1 Generalization – AVE**• AVE: The probability is the average of the inverse of the supports. (LRG is the inverse of the median of support) • Theorem 4 ave computes a dominating set of size within O(log n logΔ) of the optimal in O(log n logΔ) rounds whp.**4.2 Dominating sets with multiple coverage**• Lemma 4.2. If u is nice, then E[q(u)] ≤ 3 · q(u)/4. • Lemma 4.3. If Φ and Φ’ are the potentials at the start and end of a round, then E[Φ’] ≤ (1 − Ω(1/ logR)) · Φ. • Theorem 5 There exists a randomized distributed algorithm for MMDS that achieves an approximation ratio of O(logΔ) in expectation and O(log n) whp and a time complexity of O(log n logΔlogR) whp.**4.3 Weights on the nodes**• mds associates a weight w(u) with every node u and seeks a dominating set of minimum total weight. • Instead of comparing the rounded span of the nodes, we compare the ratio of the span to the weight of the node. We again round this value, which we refer to as the normalized span, to a nearest power of a constant b > 1 (allowing negative powers). • O(log(WΔ) log n) whp.**Open Problems**• Whether there exists a distributed O(log n)-time O(logΔ)-approximation algorithm for mds. • to determine the best approximation-time tradeoff achieveable by a deterministic distributed algorithm • k-dominating set problem**References**• Lujun Jia, Rajmohan Rajaraman, Torsten Suel, An efficient distributed algorithm for constructing small dominating sets, Distrib. Comput. (2002) 15: 193–205 • http://dcg.ethz.ch/lectures/ss04/distcomp/lecture/chapter12.pdf • http://www.dsi.uniroma1.it/~grandoni/DGP06chapter.pdf. • Devdatt Dubhashi, Fabrizio Grandoni and Alessandro Panconesi, Distributed Approximation Algorithms via LP-duality and Randomization http://www.dsi.uniroma1.it/~grandoni/DGP06chapter.pdf • CS590A Lecture Side 13 http://www.cs.purdue.edu/homes/gopal/CS590A-2007/13.pdf • B. Liang, Z. Haas. Virtual backbone generation and maintenance in ad hoc network mobility management. In Proceedings of the 2000 IEEE INFOCOM, March 2000